{- Dieser Quellfile gehrt zu DG9EPs Lauscher-Projekt, Verwendung nur unter
 - Bercksichtigung des beiliegenden licence.txt.   (C)1989-1996, DG9EP
 -}
{$A+,B-,D+,E-,F-,G+,I-,L+,N-,O-,R+,S+,V+,X-}
{$M 2024,0,0}

PROGRAM DosGpMonitor;

{$IFDEF os2} Nix. Dos bleibt Dos! {$ENDIF}

USES DOS, Monitor, dump, toolmoni;

VAR LastVector2F    : POINTER;
{  AX = $4750
	 BX = 0
	 DX = 0   (BX und DX vielleicht fr Erweiterungen)
	 ES:SI = Monitor-Header (NULL-Terminiert)
	 ES:DI = Monitor-Daten
	 CX = Lnge der Monitor-Daten
}

{$i-}
VAR pHeader,
    pDaten : POINTER;
    datLen : WORD;
    hdl    : TEXT;
    strucHeader : t_hheader;
    aDaten : t_aDaten;

PROCEDURE DoIt; Far;
  VAR e,i : WORD;
      ende : BOOLEAN;
      sHeader : STRING;
      nDaten : WORD;
BEGIN
{  Sound(440);  Delay(70); NoSound; }
{$I-}
  Inc(Word(pHeader),2);
  Inc(Word(pDaten),2);
  ende := FALSE;
  sHeader := '*';
  WHILE not ENDe Do
    BEGIN
    Ende := char(pHeader^) = #0;
    IF NoT Ende THEN
      BEGIN
      sHeader := sHeader + char(pHeader^);
      Inc(Word(pHeader));
      END;
    END;
  MOVE(pDaten^, aDaten, datLen);
  nDaten := DatLen;
  AusWerten(hdl, sHeader,aDaten,nDaten, strucHeader);
  e := IOResult;
  IF e <> 0 THEN BEGIN Writeln(' *** ',e,' ***');END;
{  WriteLn(hdl,sHeader);
  e := IOResult;
  IF e <> 0 THEN BEGIN Writeln(' ### ',e,' ###'); END;
{  Flush(hdl);}
END;

PROCEDURE SwitchOff; FAR;
BEGIN
  IF IOResult=0 THEN;;;
  Close(hdl);
  Write(#7);
  {und unkeep....}
  halt;
END;


PROCEDURE NewVector; Assembler;
ASM
	PUSHF
	CMP  AX,$4750
        JNE  @test_2
	POPF

	PUSH DS
	PUSH AX
	MOV  AX,SEG @DATA
	MOV  DS,AX

	MOV  [datLen],CX
	MOV  word ptr [pHeader+2],es
	MOV  word ptr [pHeader],si
	MOV  word ptr [pDaten+2],es
	MOV  word ptr [pDaten],di

	CALL DoIt

	POP  AX
	POP  DS

	IRET

 @test_2:
	CMP  AX,$4751
	JNE  @Old_Int
	POPF

	PUSH DS
	PUSH AX
	MOV  AX,SEG @DATA
	MOV  DS,AX

	CALL SwitchOff

	POP  AX
	POP  DS

	IRET

 @Old_Int:
	(* hier angekommen ist die Routine nicht fr mich *)
	(* Es wird die alte Prozedur angesprungen *)
	(* wenn man pfuschen wollte, knnte man den Vektor im Codesegment *)
	(* ablegen. habe ich hier aber nicht gemacht.                     *)
	popf                  (* Flags zurck *)
	push    ds
	push    bx
	push    bp
	mov     bp,sp
	mov     bx,seg @data  (* Datensegment *)
	mov     ds,bx         (* nach DS *)
	mov     bx,word ptr   [LastVector2F+2] (* Segment holen *)
	xchg    word ptr ss:[bp+4],bx          (* auf den Stack *)
	push    bx                             (* alten ds Wert merken *)
	mov     bx,word ptr   [LastVector2F+0] (* Offset holen *)
	xchg    word ptr ss:[bp+2],bx          (* und als Original *)
	pop     ds                             (* alter ds Wert wo er hinsoll *)
	pop     bp                             (* BP auch zurck *)
	retf                                   (* FAR Return = Ansprung *)
END;


BEGIN
{$I-}
  SetVersion('Monitor-GP/DOS','6.5.96');
  Assign(output,'');
  Rewrite(output);
  IF IOResult <> 0 THEN
    BEGIN
    WriteLn('stdouterror');
    END;
  Filemode := 42;
  Assign(hdl,'TEST.TXT');
  Rewrite(hdl);
  IF IOResult <> 0 THEN
    BEGIN
    WriteLn('InOutError');
    Halt;
    END;
  Writeln(hdl,'FirstLine');
  IF IOResult <> 0 THEN
    BEGIN
    WriteLn('InOutError');
    Halt;
    END;
  DoIt;
  GetIntVec($2F,LastVector2F);
  SetIntVec($2F,@NewVector);
  Keep(0);
END.
