UNIT portpas;

{$I portpas.inc}


INTERFACE

{$IFDEF VP} USES OS2DEF; {$ENDIF}

CONST
      csOS=
          {$IFDEF DOS}          'DOS'
          {$ELSE}
             {$IFDEF DPMI}      'DOS-DPMI'
             {$ELSE}
                {$IFDEF MSDOS}  'MSDOS'
                {$ENDIF}
             {$ENDIF}
          {$ENDIF}
          {$IFDEF OS2}       'OS/2'     {$ENDIF}
          {$IFDEF Linux}     'Linux'    {$ENDIF}
          {$IFDEF Windows}   'Win'      {$ENDIF}
          {$IFDEF PMVersion} 'PM'       {$ENDIF}
      ;
      csCPU=  {$IFDEF m68k}     'm68000'      {$ELSE}
              {$IFDEF alpha}    'alpha'       {$ELSE}
              {$IFDEF FPK}      'i386'        {$ELSE}
              {$IFDEF BP}
                     {$IFOPT G+} 'i286'
                        {$ELSE} 'i86'
                       {$ENDIF}               {$ELSE}
              {$IFDEF OS2}      'i386'        {$ELSE}
                                'unknown CPU'
              {$ENDIF} {$ENDIF} {$ENDIF} {$ENDIF} {$ENDIF}
      ;


      csCOMPILER=
          {$IFDEF FPK} 'FPK'   {$ENDIF}
          {$IFDEF BP}  'BP'    {$ENDIF}
          {$IFDEF BP2} 'BP/2'  {$ENDIF}
          {$IFDEF VP}  'VP'    {$ENDIF}
      ;


      csPLATTFORM=csOS+'/'+csCPU+'/'+csCompiler;


TYPE TP_BYTE=^BYTE;
     LInteger = {$IFDEF FPK_VP} LongInt{$ELSE}InTeger{$ENDIF};
     LWord    = {$IFDEF FPK_VP} LongInt{$ELSE}Word{$ENDIF};


     {$IFDEF VP}     USHORT   = APIRet16;     {$ENDIF}

     T_valres   = {$IFDEF FPK} WORD {$ELSE}
                  {$IFDEF VP} LongInt {$ELSE}
                              INTEGER
                  {$ENDIF} {$ENDIF};
     T_GetDate = {$IFDEF VP} Longint {$ELSE} Word {$ENDIF};
     T_GetTime = T_GetDate;

PROCEDURE IncP1(Var p : Pointer);
PROCEDURE IncPn(Var p : Pointer; n : Longint);
{$IFDEF fpk}
  function Swap(X : Word) : Word;
{$ENDIF}


IMPLEMENTATION


PROCEDURE IncP1(Var p : Pointer);
BEGIN
  {$IFDEF fpk}
    p := p + 1;
  {$ELSE}
    Inc(tp_byte(p));
  {$ENDIF}
END;

PROCEDURE IncPn(Var p : Pointer; n : Longint);
BEGIN
  {$IFDEF fpk}
    p := p + n;
  {$ELSE}
    Inc(tp_byte(p),n);
  {$ENDIF}
END;

{$IFDEF fpk}
  function Swap(X : Word) : Word;
  BEGIN
    swap := ( lo(x) SHL 8 ) OR ( hi(x) );
  END;
{$ENDIF}


END.
