{$M 26384,0,655360}
{- Dieser Quellfile gehrt zu DG9EPs Lauscher-Projekt, Verwendung nur unter
 - Bercksichtigung des beiliegenden licence.txt.  (C)1989-1996, DG9EP
 -}

{$I vpbp.inc}
PROGRAM Monitor_SaveFiles;

{$D AX.25 Lauscher/2 - Offline Version fr MonitorFiles - (c)DG9EP}

{$IFDEF bp2}{$M 14412, 8192}{$ENDIF}
{$IFDEF vp} {$M 114412}{$ENDIF}

{$IFDEF vp}   {$T-}
{$ELSE}       {$A+,B-,D+,F-,G+,I+,K+,L+,N-,P-,Q+,R+,S+,T+,V+,X-,Y+}
{$ENDIF}

USES {WinCrt,} ToolMoni, Monitor,  Dump, FD_Div, Mo_def,
     CRT, Dos;

PROCEDURE Main;
  Label leol;
  VAR len, nDaten : LongInt;
      aDaten      : T_aDaten;  { s. Monitor.pas }
      hdlSave     : Text;
      DirInfo     : SearchRec;
      strucHeader : t_hHeader;
      sZeile, sHeader, sFileName : STRING;
      D     : DirStr;
      N     : NameStr;
      E     : ExtStr;
BEGIN
  SetVersion('MoniSave','1.6.96');
  PostInit;
  CheckBreak := True;
  WriteLn;  WriteLn;
  TextAttr := 15;

  csINIFILEINAME := 'Moni_sav.ini';
  sSpyDir := sSpyDir+'.SAV';
  sBBSDir := sBBSDir+'.SAV';

  IF paramStr(1) =  '' THEN
    BEGIN
    WriteLn;
    WriteLn(' Dateinamen (auch Wildcards) angeben:  MONI_SAV filename');
    Halt(222);
    END;

  {$I-}
  sFileName := paramStr(1);
  FSplit(FExpand(paramStr(1)),d,n,e);
  FindFirst(paramStr(1), AnyFile, DirInfo);
  WHILE DosError = 0 do
    BEGIN
    sFileName  := d+DirInfo.Name;
    Pausiere(' Gleich geht''s los mit der Datei: '+sFileName);
    Assign(hdlSave,sFileName);
    Reset (hdlSave);
    IF IOResult <> 0 THEN
      BEGIN
      WriteLn;
      WriteLn(sFileName,' not found');
      Halt(223);
      END;

    sHeader := '';
    nDaten := 0;
    WHILE Not Eof(hdlSave) DO
      BEGIN             {$I-}
      IF Keypressed THEN IF DoReadKey(ReadKey) THEN Goto lEol;

      ReadLn(hdlSave,sZeile);
      IF (Copy(sZeile,1,3)='fm ') OR (Copy(sZeile,2,4)=':fm ')
        THEN BEGIN
             IF sHeader<>'' THEN
               BEGIN
               IF (nDaten>=215) AND (aDaten[nDaten]=#13) THEN Dec(nDaten);
               Auswerten( output, sHeader, aDaten, nDaten, strucHeader);
               nDaten := 0;
               END;
             sHeader := sZeile;
             END
        ELSE BEGIN
             len := length(sZeile);
             IF (nDaten+len+1) > sizeof(aDaten) THEN len := 0;
             Move (sZeile[1], aDaten[nDaten+1], len);
             Inc(nDaten, len );
             sZeile := #13;
             Move (sZeile[1], aDaten[nDaten+1], 1);
             Inc(nDaten, 1 );
             END;
      END;{while}

    Close(hdlSave);
    FindNext(DirInfo);
    END;
leol:
  SetTextAttr(_LightCyan_White);
  WriteLn('----------------------------------------------------------------------');
  WriteNPID( output );
  WriteLn('----------------------------------------------------------------------');
  SetTextAttr(_White_Black);
END;

BEGIN
  Main;
END.

