{- Dieser Quellfile gehrt zu DG9EPs Lauscher-Projekt, Verwendung nur unter
 - Bercksichtigung des beiliegenden licence.txt.   (C)1989-1995, DG9EP
 -}

{$I monisys.inc}

UNIT ToolMoni;


{* Enthlt alle Oberflchenelemente *}

INTERFACE
  USES mo_def,portpas;


  CONST    NLINEDATAWINDOW : WORD = 10;
           fSingleStep : BOOLEAN=false;
  VAR      pSysHdl : TP_TEXT;

  PROCEDURE WriteFehler(n : WORD);
   FUNCTION DoReadKey(Ch : CHAR) : BOOLEAN; {* Die muss hin und wieder mir Readkey als Parameter aufgerufen werden *}
  Procedure DatenFenster;
  Procedure StatusFenster;
  PROCEDURE WriteStatus;
  PROCEDURE WriteStatusPara(CONST sPara:String);
  PROCEDURE Pausiere(CONST s : STRING);
  PROCEDURE PostInit;
  PROCEDURE SetVersion(CONST sName,sVersion:STRING);
  PROCEDURE SetSysMeldungHandle( pHdl : TP_TEXT);

  CONST sPgmName    : STRING[90]='';
        sPgmVersion : STRING[90]='';
        nZeilen     : BYTE = 25;
        fGlobStopAnzeige : BOOLEAN = FALSE;
        {* Ist genau dann True, wenn Leertaste gedrckt, und Scrolllock blinkt *}
        fDebug : BOOLEAN = FALSE;

{-------------------------------------------------------------------------}
IMPLEMENTATION

 USES Monitor, Dump,
      CRT,
      FD_DIV
     {$IFDEF bp2} ,BSESUB, BSEDOS {$ENDIF}
     {$IFDEF vp} {$IFDEF PMVersion},wincrt {$ENDIF},os2def, os2base {$ENDIF}
     ;


PROCEDURE WriteFehler(n : WORD);
  VAR s : STRING;
BEGIN
  CASE n of
   231 : s := 'Pipe ist andersweitig beschftigt';
   233 : s := 'Pipe wurde vom Server (GP/2 bzw. FlexPacket/2) abgehngt';
  ELSE s := '';
  END;
  Pausiere('Fehler: '+s+' ('+f_Str(n)+')');
END;


PROCEDURE SetSysMeldungHandle( pHdl : TP_TEXT);
BEGIN
  pSysHdl := pHdl;
END;



PROCEDURE SetVersion(CONST sName,sVersion:STRING);
BEGIN
  sPgmName    := sName;
  sPgmVersion := sVersion+'/'+csKernelVersion;
  WriteStatus;
END;


FUNCTION StrReplay(x: T_REPLAY): STRING;
BEGIN
  CASE x of
     cNO    : StrReplay := 'Aus';
     cALL   : StrReplay := 'Alles';
     cFREMD : StrReplay := 'FremdPID';
     ELSE  StrReplay := '';
     END;
END;
FUNCTION StrSuch(x: T_Such): STRING;
BEGIN
  CASE x of
     cNOSEARCH: StrSuch := 'aus';
     cINCL    : StrSuch := 'EINSCHL.';
     cEXCL    : StrSuch := 'AUSSCHL.';
     ELSE       StrSuch := '?';
     END;
END;



 CONST nStopTrue : WORD = 0;
PROCEDURE AnzeigeStop;
BEGIN
  IF fGlobStopAnzeige THEN Inc(nStopTrue);
  fGlobStopAnzeige := True;
END;
PROCEDURE AnzeigeWeiter;
BEGIN
  IF nStopTrue>0 THEN Dec(nStopTrue);
  fGlobStopAnzeige := nStopTrue>0;
END;


 CONST bCurrentWindow:BYTE=1;
       x1:BYTE=1;  y1:BYTE=1;
       x2:BYTE=1;  y2:BYTE=1;
PROCEDURE DatenFenster;
BEGIN
  IF cHIDDEN THEN Exit;
  IF bCurrentWindow=1 THEN Exit;
  Flush(output);
  x2 := WhereX;
  y2 := WhereY;
  bCurrentWindow := 1;
  Window( 1, 1,
         80, nZeilen-4);
  TextAttr:= FARBE_MONI_DEFAULT;
  GotoXY(x1,y1);
  NLINEDATAWINDOW := nZeilen-4;
END;

PROCEDURE StatusFenster;
BEGIN
  IF cHIDDEN THEN Exit;
  IF bCurrentWindow=2 THEN Exit;
  Flush(output);
  x1 := WhereX;
  y1 := WhereY;
  bCurrentWindow := 2;
  Window(1,nZeilen-3,
        79,nZeilen);
  TextAttr := FARBE_STATUS_DEFAULT;
  GotoXY(x2,y2);
END;


  CONST ReadState : (cBEFEHL,cSTRING)=cBEFEHL;
        psReadWork : TP_STRING = nil;
        bStateScreenNr : BYTE = 1;
        cMAXStateScreenNr = 5;
        wCurrSpyIndex : Integer = 1;
        wRichtung : ShortInt = 1;

PROCEDURE WriteStatusPara(CONST sPara:String);
  VAR ispy : WORD;
BEGIN
  IF cHIDDEN THEN Exit;
  AnzeigeStop;
  StatusFenster;
  Flush(output);
  TextAttr := FARBE_STATUS_HINTERGRUND;
  ClrScr;
  IF bStateScreenNr = 3
    THEN BEGIN
         WriteNPID( output );
         WriteLn;
         WriteLn(sAddStatusInfo);
         END
    ELSE IF bStateScreenNr = 4
    THEN BEGIN
         WriteLn( csWriteSpyTitel );
         iSpy := 0;
         IF wCurrSpyIndex < 1 THEN wCurrSpyIndex := MaxSpy
         ELSE IF wCurrSpyIndex > MaxSpy THEN wCurrSpyIndex := 1;
         WHILE (iSpy <= MaxSpy) AND (aSpy[wCurrSpyIndex].Id = 0) DO
           BEGIN
           Inc(iSpy);
           wCurrSpyIndex := wCurrSpyIndex+wRichtung;
           IF wCurrSpyIndex < 1 THEN wCurrSpyIndex := MaxSpy
           ELSE IF wCurrSpyIndex > MaxSpy THEN wCurrSpyIndex := 1;
           END;
         IF aSpy[wCurrSpyIndex].Id > 0 THEN WriteOneSpy(output,wCurrSpyIndex);
         Write(' <-  ->  F5');
         END
    ELSE IF bStateScreenNr = 5
    THEN BEGIN
         Flush(output);
         TextAttr := FARBE_STATUS_Seite2;
         WriteLn('QSO-Spy Filter ('+StrSuch(opt.qsoFilterMode)+'): "',opt.sQSOFilter,'"   ');
         WriteLn('Mailrubrik Filter ('+StrSuch(opt.rubrikFilterMode)+'): "',opt.sRubrikFilter,'"   ');
         WriteLn('Anzeigefilter Header ('+strSuch(opt.suchHead)+'): "',opt.sSuchHead,'"  ');
         Write  ('              Daten ('+StrSuch(opt.suchData)+'): "',opt.sSuchData,'"  ');
         END
    ELSE BEGIN { Seiten 2 & 1 }
         WriteLn(
             'T=Textkrper(',  fBool2Str(opt.fAXBodyZeigen),')'
            ,' R=Broadcast RX(',fBool2Str(opt.fBcRx),   ',',nBCPaketeRx,  '/',nBCFilesRx,')'
            ,' M=MailSpy(',     fBool2Str(opt.fMailSpy),',',nMSHeaderSeen,'/',nMSFilesRx,')'
            ,' S=Spy(',         fBool2Str(opt.fQSOSpy),    ',',nSpy,')'
            );

         IF bStateScreenNr=1 THEN
           BEGIN
           Flush(output);
           TextAttr := FARBE_STATUS_Seite1;
           Write(
                'A=AX25 zeigen(',     fBool2Str(opt.fShowAx),')'
              +' F=Fremd-PID zeigen(',fBool2Str(opt.fShowPID),')'
              +' J=RR zeigen(',       fBool2Str(NOT opt.fOnlyDataFrames),')'
              +' C=//Comp(',          fBool2Str(opt.fSpCompressDecoder),')'
              + sPara
              + #13#10
              +'P=rePlay erzeugen(',StrReplay(fnReplayCopy),')'
              +' B=Binrdaten(',fBool2Str(opt.fDatenBinaer),')'
              +' Q=Piepen(',fBool2Str(opt.fBeep),')'
              +' V=Statusmeld.(',fBool2Str(opt.fSystemMeldungen),')'
           );
           END;

         IF bStateScreenNr=2 THEN
           BEGIN
           Flush(output);
           TextAttr := FARBE_STATUS_Seite2;
           Write('Strg+D=Daten suchen('+StrSuch(opt.suchData)+') D=');
           Flush(output);
           IF ReadState = cSTRING THEN TextAttr := FARBE_EINGABE_FELD;
           Write('Daten-Suchausdruck:"',opt.sSuchData,'"  ');
           Flush(output);
           TextAttr := FARBE_STATUS_Seite2 ;
           Write(#13#10,
                 'Strg+H=Headersuche('+strSuch(opt.suchHead)+')  H=');
           Flush(output);
           IF ReadState = cSTRING THEN TextAttr := FARBE_EINGABE_FELD;
           Write('Headerausdruck:"',opt.sSuchHead,'"  ');
           END;

         Flush(output);
         TextAttr := FARBE_STATUS_HINTERGRUND;
         Write(#13#10+'TAB=Statusanz.wechs. <Leer>,N=Pause  ESC=Ende ',sPgmName,
               ' & zurck zu '+ csOS
         );
         END;
  DatenFenster;
  AnzeigeWeiter;
  IF IOResult <>0 THEN;;;
END;

PROCEDURE WriteStatus;
BEGIN
  WriteStatusPara('');
END;



PROCEDURE Pausiere(CONST s : STRING );
  VAR c : CHAR;
BEGIN
  IF cHIDDEN THEN Exit;
  fsinglestep := false;
  ScrollLed(cOn);
  AnzeigeStop;
  StatusFenster;
  ClrScr;
  Flush(output);
  TextAttr := FARBE_PAUSIERE;
  WriteLn(s);
  Flush(output);
  TextAttr := FARBE_PAUSIERE OR BLINK;
  Write('    (Fortsetzen mit <Leertaste> oder "E" )');
{  DatenFenster; }
  REPEAT
    While (NOT KeyPressed) DO
      BEGIN
      Delay(300);
      ScrollLed(cToggle);
      END;
    c := ReadKey;
    fSinglestep := upcase(c)='E';
  UNTIL (c=' ') OR fSinglestep;
  WriteStatus;
  AnzeigeWeiter;
  ScrollLed(cOff);
END;



FUNCTION DoReadKey(Ch : CHAR) : BOOLEAN;
{* Kehrt mit True zurck, wenn Programm beendet werden soll *}
  VAR fEnde : BOOLEAN;
BEGIN
  DoReadKey := false;
  IF cHidden THEN Exit;
  fEnde := FALSE;
  IF cHIDDEN THEN Exit;
  IF ReadState = cSTRING THEN
    BEGIN
    IF      Ch =  #8 THEN Delete(psReadWork^, length(psReadWork^), 1)
    ELSE IF (Ch = #13) OR (ch=#27) THEN
                          BEGIN
                          psReadWork := nil;
                          ReadState := cBEFEHL
                          END
                     ELSE psReadWork^ := psReadWork^ + ch;
    WriteStatus;
    Exit;
    END;

  CASE upcase(ch) OF
      #0  : {Write( ORD(ReadKey):4);}
            CASE ReadKey OF
              Key_links,
              key_up
                : BEGIN
                  wRichtung := -1; Dec(wCurrSpyIndex); bStateScreenNr := 4;
                  END;
              key_rechts,
              key_down
                : BEGIN
                  wRichtung := 1; Inc(wCurrSpyIndex); bStateScreenNr := 4;
                  END;
              key_home
                : BEGIN
                  wRichtung := 1; wCurrSpyIndex :=1; bStateScreenNr := 4;
                  END;
              key_end
                : BEGIN
                  wRichtung := -1; wCurrSpyIndex :=maxspy; bStateScreenNr := 4;
                  END;
              key_f10
                : BEGIN
                  wCurrSpyIndex := globalLastSpyIndex; bStateScreenNr := 4;
                  END;
              key_f1 : bStateScreenNr := 1;
              key_f2 : bStateScreenNr := 2;
              key_f3 : bStateScreenNr := 3;
              key_f4 : bStateScreenNr := 4;
              key_f5 : bStateScreenNr := 5;
            END;
      ' ' : BEGIN
            Pausiere('  Pause ');
            END;
      'A' : BEGIN
            opt.fShowAx := NOT opt.fShowAx;
            bStateScreenNr := 1;
            END;
      'B' : BEGIN
            opt.fDatenBinaer := NOT opt.fDatenBinaer;
            bStateScreenNr := 1;
            END;
      'C' : BEGIN
            opt.fSpCompressDecoder := NOT opt.fSpCompressDecoder;
            bStateScreenNr := 1;
            END;
      ^D  : BEGIN
            {opt.SuchData :=}
            Inc(opt.Suchdata);
            IF opt.Suchdata = cEoEnumType THEN opt.Suchdata := T_Such(0);
            bStateScreenNr := 2;
            END;
      'D' : BEGIN
            {* Ausschalten, damit bei der Ausgabe keine Teilstrings gesucht werden *}
            ReadState := cSTRING;
            psReadWork := @opt.sSuchData;
            bStateScreenNr := 2;
            END;
      'E' : Pausiere('Einzelschritt');
      'F' : BEGIN
            opt.fShowPID:= NOT opt.fShowPID;
            bStateScreenNr := 1;
            END;
      ^H  : BEGIN
            Inc(opt.SuchHEad);
            IF opt.Suchhead = cEoEnumType THEN opt.Suchhead := T_Such(0);
            bStateScreenNr := 2;
            END;
      'H' : BEGIN
            ReadState := cSTRING;
            psReadWork := @opt.sSuchHead;
            bStateScreenNr := 2;
            END;
       ^I : BEGIN {* TAB *}
            Inc(bStateScreenNr);
            IF bStateScreenNr > cMAXStateScreenNr THEN bStateScreenNr := 1;
            END;
      'J' : BEGIN
            opt.fOnlyDataFrames := NOT opt.fOnlyDataFrames;
            bStateScreenNr := 1;
            END;
      'M' : BEGIN
            opt.fMailSpy := NOT opt.fMailSpy;
            END;
      'N' : BEGIN
            DatenFenster;
            Flush(output);
            TextAttr := FARBE_SYSTEMMELDUNG;
            WriteLn;
            IF opt.fQSOSpy THEN
              BEGIN
              WriteLn('------------- Spione ---------------------------------------------------');
              WriteSpy( output );
              Pausiere('');
              END;
            WriteLn('------------ Protokoll-Statistik ---------------------------------------');
            WriteNPID( output );
            WriteLn('------------------------------------------------------------------------');
            Pausiere('');
            END;
      'P' : BEGIN
            Replay( IncReplay(fnReplayCopy) ,'');
            bStateScreenNr := 1;
            END;
      'Q' : BEGIN
            opt.fBeep := NOT opt.fBeep;
            bStateScreenNr := 1;
            END;
      'R' : BEGIN
            opt.fBcRx := NOT opt.fBcRx;
            END;
      'S' : BEGIN
            opt.fQSOSpy := NOT opt.fQSOSpy;
            IF NOT opt.fQSOSpy THEN CloseAllSpy;
            END;
      'T' : BEGIN
            opt.fAXBodyZeigen := NOT opt.fAXBodyZeigen;
            END;
      'V' : BEGIN
            opt.fSystemMeldungen := NOT opt.fSystemMeldungen;
            END;
      ^Z  : BEGIN
            fDebug:= NOT fDebug;
            END;
       'X',
       #27,
       ^C : BEGIN
            fEnde := TRUE;
            WriteLn;
            WriteLn(' Ende.....');
            END;
      END;{case}
  WriteStatus;
  DoReadKey := fEnde;
END;


PROCEDURE WriteVers;
BEGIN
  Flush(output);
  SetTextAttr(FARBE_DOS);
  WriteLn(sPgmName, ' (',csPLATTFORM,') ', sPgmVersion, ', ',csCOPYRIGHT );
  WriteLn(csCREDITS);
END;

{* DL2EAA: Test fr /COMP
 * DG9FDL: Pascal Interface fr PCFlex
 * DL8HBS: BC-Referenz-Routinen
 *}


  VAR ExitSave : Pointer;
PROCEDURE DoExit; FAR;
BEGIN
  IF opt.fBeep THEN
    BEGIN
    Beep(840, 50); Delay(100);
    Beep(840, 50); Delay(100);
    Beep(840, 50); Delay(100);
    Beep(840,180); Delay(100);
    Beep(840, 50); Delay(100);
    Beep(840,180); Delay(100);
    END;
  IF NOT cHIDDEN THEN
    BEGIN
    WriteLn;
    StatusFenster;
    Flush(output);
    SetTextAttr(FARBE_DOS);
    ClrScr;
    DatenFenster;
    WriteVers;
    END;
  Exitproc := exitSave;
END;


PROCEDURE PostInit;
BEGIN
  IF cHIDDEN THEN Exit;
  WriteVers;
  Writeln('Verwendet werden ',nZeilen,' Bildschirmzeilen ');
END;


{$IFDEF os2}
  var rc : WORD;
      vmi : VioModeInfo;
{$ENDIF}
BEGIN
  {$IFDEF PMVersion}
  {* Select 10 x 6 System VIO font *}
  FontAttr.lMaxBaselineExt := 14;
  FontAttr.lAveCharWidth := 6;
  Screensize.x :=92;
  Screensize.y :=25;
  {$ENDIF}
  {$IFDEF MSDOS}
    {$IFDEF fpk}
    nZeilen := 25;
    {$ELSE}
    nZeilen := Mem[SEG0040:$84]+1;
    {$ENDIF}
  {$ENDIF}

  pSysHdl := @output;

  Filemode := {$IFDEF os2} 42  {$ELSE}   2  {$ENDIF};
  CheckBreak := True;
  Randomize;
  {$IFDEF OS2}
    vmi.cb := sizeof(vmi);
    {$IFDEF BP2}   rc := VioGetMode(PVIOMODEINFO(@vmi),0); {$ENDIF}
    {$IFDEF VP}    rc := VioGetMode(vmi,0); {$ENDIF}
   {Writeln('get rc:',rc);
    Writeln(vmi.col,'*',vmi.row);
    vmi.row := 50;
    rc := VioSetMode(@vmi,0);
    Writeln('set rc:',rc);
   }
   if rc = 0 then nZeilen := vmi.row;
  {$ENDIF}

  IF NOT cHIDDEN THEN
    BEGIN
    WriteStatus;
    DatenFenster;
    ClrScr;
    exitsave := exitproc;
    exitproc := @doexit;
    END;
END.

